package com.gxzc.zen.api.sys.service.impl

import com.baomidou.mybatisplus.plugins.Page
import com.baomidou.mybatisplus.service.impl.ServiceImpl
import com.gxzc.zen.api.sys.mapper.SysRoleMapper
import com.gxzc.zen.api.sys.model.SysRole
import com.gxzc.zen.api.sys.service.ISysRoleService
import org.springframework.stereotype.Service

/**
 * <p>
 * 角色表 服务实现类
 * </p>
 *
 * @author NorthLan123
 * @since 2018-02-06
 */
@Service
class SysRoleServiceImpl : ServiceImpl<SysRoleMapper, SysRole>(), ISysRoleService {

    override fun getListByParam(name: String?, code: String?, enable: Boolean?): MutableList<SysRole> {
        val params: LinkedHashMap<String, Any?> = linkedMapOf(
                "name" to name,
                "code" to code
        )
        if (enable != null) {
            params["enable"] = enable
        }
        return baseMapper.selectByParams(params)
    }

    override fun getListByParamPage(name: String?, code: String?, enable: Boolean?, current: Int, size: Int): Page<SysRole> {
        val page = Page<SysRole>(current, size)
        val params: LinkedHashMap<String, Any?> = linkedMapOf(
                "name" to name,
                "code" to code
        )
        if (enable != null) {
            params["enable"] = enable
        }
        page.records = baseMapper.selectByParamsPage(page, params)
        return page
    }
}
