package com.gxzc.zen.common.util

import org.springframework.cache.Cache
import org.springframework.cache.CacheManager
import kotlin.reflect.KClass

/**
 * 缓存工具类
 * @author NorthLan at 2018/2/8
 */
object CacheUtil {
    private val cacheManager = SpringContextHolder.getBean(CacheManager::class.java)

    fun getCahce(key: String): Cache? {
        return cacheManager.getCache(key)
    }

    fun <T : Any> get(cacheKey: String, key: Any, type: KClass<T>): T? {
        return getCahce(cacheKey)?.get(key, type.java)
    }

    fun get(cacheKey: String, key: Any): Cache.ValueWrapper? {
        return getCahce(cacheKey)?.get(key)
    }

    fun put(cacheKey: String, key: Any, value: Any) {
        getCahce(cacheKey)?.put(key, value)

    }

    fun putIfAbsent(cacheKey: String, key: Any, value: Any) {
        getCahce(cacheKey)?.putIfAbsent(key, value)
    }
}